# Goro-Launcher

**Goro-Launcher** は、ホットキー操作と階層メニューを提供する常駐型ランチャーです。タスクトレイにアイコンを表示し、効率的にアプリケーションやファイルを起動できます。設定はYAMLファイルで簡単に行うことができ、柔軟なカスタマイズが可能です。

## 主な機能

- **常駐型ランチャー**: タスクトレイに常駐し、いつでもランチャーメニューを開くことができます。
- **ホットキー呼び出し**: キーボードのホットキーを使って、素早くランチャーを呼び出せます。
- **KeyMap 機能**: 設定されたKeyMapに基づいて、指定のキーを押すことで関連するメニューを瞬時に開くことができます。
- **階層式メニュー**: メニューは階層構造を持ち、整理された項目の管理が可能です。
- **YAML形式での設定**: メニュー、ホットキー、KeyMapはすべて人間に読みやすいYAML形式で設定されます。

## インストール
Windows起動時にgoro-launcherを起動するインストール方法を説明します。

### exeを作る方法
1. piinstallerでgoro-launcher.pyからgoro-launhcer.exeを作ります。
2. **適当なフォルダを作りそこに
goro-launcer.exe
icon.png
menu.yaml
を入れます。
3. **goro-lancher.exe のショートカットを作ります。（右クリック＞送る＞デスクトップにショートカットを作る）
4. **デスクトップに作られたショートカットを
"C:\Users\%USERNAME%\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup"へ保存します。
以上で起動時にgoro-launcher.exeが自動的に起動します。

### goro-launcer.pyをpythonから起動する方法
この場合一瞬起動時にコンソール画面が表示されます。

1. pythonをインストールします。
2. 適当なフォルダを作ってpythonのvenv環境を作ります。
3. 作ったフォルダで
python -m pip install -r freeze.txt を行い必要なライブラリをインストールします。
4. goro-launcer-run.batのショートカットを作ります。
5. スタートアップフォルダに作成したショートカットをコピーします。
以上で作ったvenv環境内でactiveになりgoro-launcher.pyを起動します。

## 使用方法

1. **タスクトレイにアイコン表示**: Goro-Launcherは起動すると、タスクトレイにランチャーアイコンが表示されます。
2. **ホットキーで呼び出し**: 設定したホットキーを押すと、メニューが表示されます。デフォルトでは "Ctrl+Alt+N"です。
3. **KeyMapでメニューを開く**: Key Mapで指定したキーを押すと、そのキーに紐付けられたメニューが自動で開きます。
   - 各メニューの先頭には対応するキーが表示されており、該当キーを押すことでメニューを展開します。
4. **メニュー階層**: メニューは階層的に構成されており、必要な機能やアプリケーションにすばやくアクセスできます。

## 設定ファイル（YAML）
menu.yamlの設定項目。
- **hot_key**: ホットキーの設定を管理します。
- **key_map**: Key Mapの設定を行い、キーとメニューの関連付けをします。
- **menu**: メニューの構成や表示順を管理します。

**日本語用のメニューファイル**が用意されています。manu.japanese.yamlをmenu.yamlに変更して使ってください。

### `menu.yaml`
サンプルが付いています。
使い方やなどもサンプル内に書いてあります。
アプリケーションの起動の他に、HPのブックマークやフォルダーの登録方法（文章なども同じ）等が説明されています。アプリケーションによって起動の条件を整えなければならい場合の別スクリプトを用意する方法なども説明されています。

### 動作環境

以下の環境で動作確認しています。

- Windows10
- python 3.11.9

### 問題があった場合
- hwndを操作しているのでセキュリティーソフトで問題があるかもしれません。その場合は、例外処理をしてください。

### ライセンス
GPL v3.0です。

### リンク
Website: [https://goro-bizaid.com](https://goro-bizaid.com)  
X (formerly Twitter): [https://x.com/Goro_bizaid](https://x.com/Goro_bizaid)